package com.qr.flutter_toolkit;

import com.qr.flutter_toolkit.gps_location.GPSLocationHandler;
import com.qr.flutter_toolkit.package_info.PackageInfoHandler;

import io.flutter.plugin.common.EventChannel;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/**
 * FlutterToolkitPlugin
 */
public class FlutterToolkitPlugin {
    private final static String TOOLKIT_PATH_PROVIDER_METHODS = "com.qr.flutter_toolkit/path_provider/methods";
    private final static String TOOLKIT_PACKAGE_INFO_METHODS = "com.qr.flutter_toolkit/package_info/methods";
    private final static String TOOLKIT_GEOLOCATION_METHODS = "com.qr.flutter_toolkit/gps_location/methods";
    private final static String TOOLKIT_GEOLOCATION_EVENTS = "com.qr.flutter_toolkit/gps_location/events";

    /**
     * Plugin registration.
     */
    public static void registerWith(Registrar registrar) {
        MethodChannel pathProviderMethodChannel = new MethodChannel(registrar.messenger(), TOOLKIT_PATH_PROVIDER_METHODS);
        pathProviderMethodChannel.setMethodCallHandler(new PackageInfoHandler(registrar));

        MethodChannel packageInfoMethodChannel = new MethodChannel(registrar.messenger(), TOOLKIT_PACKAGE_INFO_METHODS);
        packageInfoMethodChannel.setMethodCallHandler(new PackageInfoHandler(registrar));

        MethodChannel geolocationMethodChannel = new MethodChannel(registrar.messenger(), TOOLKIT_GEOLOCATION_METHODS);
        EventChannel geolocationEventChannel = new EventChannel(registrar.messenger(), TOOLKIT_GEOLOCATION_EVENTS);
        GPSLocationHandler GPSLocationHandler = new GPSLocationHandler(registrar);
        geolocationMethodChannel.setMethodCallHandler(GPSLocationHandler);
        geolocationEventChannel.setStreamHandler(GPSLocationHandler);

    }
}
