import 'package:flutter/material.dart';
import 'dart:async';

import 'package:permission_handler/permission_handler.dart';
import 'package:flutter_toolkit/gps_location.dart';
import 'package:flutter_toolkit/package_info.dart';
import 'package:flutter_toolkit/path_provider.dart';

void main() => runApp(MyApp());

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _platformVersion = 'Unknown';
  String _error = "";

  @override
  void initState() {
    super.initState();
    PermissionHandler()
        .requestPermissions([PermissionGroup.location]).then((value) async {
        if(value[PermissionGroup.location].value == PermissionStatus.granted.value){
          GPSLocation.getGPSLocationStream.listen((value){
            print(value.toString() + "11111");
          },onError: (e){
            print(e.toString());
          },onDone: (){
            print("onDone111");
          });
          await Future.delayed(Duration(seconds: 5));
          GPSLocation.getGPSLocationStream.listen((value){
            print(value.toString() + "22222");
          },onError: (e){
            print(e.toString());
          },onDone: (){
            print("onDown222");
          });
        }
      setState(() {});
    });
    initPlatformState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {
    String platformVersion;
    // Platform messages may fail, so we use a try/catch PlatformException.
    try {
//      platformVersion = (await Geolocation.getLastKnownGeolocation)?.toString();
    } catch (e) {
      platformVersion = e.toString();
    }

    // If the widget was removed from the tree while the asynchronous platform
    // message was in flight, we want to discard the reply rather than calling
    // setState to update our non-existent appearance.
    if (!mounted) return;

    setState(() {
      _platformVersion = platformVersion;
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Center(
          child: Column(
            children: <Widget>[
              Text('Running on: $_platformVersion\n'),
              Text("Error:$_error"),
            ],
          ),
        ),
      ),
    );
  }
}
